package com.kakao.events;

import com.kakao.network.NetworkTask;
import com.kakao.network.response.ResponseBody;
import com.kakao.network.response.ResponseData;

import java.io.IOException;
import java.util.List;

/**
 * S2 이벤트 API 요청을 담당한다.
 * @author kevin.kang
 * Created by kevin.kang on 2016. 8. 22..
 */

class EventsApi {
    /**
     * 이벤트를 publish하는 API를 호출한다.
     * @param appKey 현재 앱의 앱키
     * @param rootEvent Top-Level attribute들을 담고 있는 이벤트 object
     * @param leafEvents Batching되어 보내질 이벤트 리스트. 싱글 이벤트를 보낼 때에는 빈 리스트가 넘겨진다.
     * @return EventsLogResponse 리퀘스트가 성공했을 경우 response를 담은 object
     * @throws IOException
     * @throws ResponseBody.ResponseBodyException
     * @throws EventsLogResponse.EventsLogErrorResponseException
     */
    static EventsLogResponse requestLoggingEvents(final String appKey, Event rootEvent, List<Event> leafEvents) throws IOException, ResponseBody.ResponseBodyException, EventsLogResponse.EventsLogErrorResponseException {
        NetworkTask networkTask = new NetworkTask();
        ResponseData result = networkTask.request(new EventsLogRequest(appKey, rootEvent, leafEvents));
        return new EventsLogResponse(result);
    }
}
